
;CUERPO TIPICO DE UN PROGRAMA EN ASM


; 1)  ZONA DE DEFINICION DE ETIQUETAS Y FICHEROS DE DEFINICION DEL PIC

F84A EQU 1          ;0=PIC16F84 1=PIC16F84A TIPO
F12MHZ EQU 1           ;0- 4Mhz 1=12Mhz
; NOTA: EQU viene de EQUAL y se utiliza para asignar un valor a la etiqueta.
; Estas se usan en este caso para controlar que partes del codigo van a ser compiladas

 IF        F84A
 list      p=16F84A
 include   "p16F84A.inc"
 ELSE
 list      p=16F84
 include   "p16F84.inc"
 ENDIF

; 2) ZONA DE CONFIGURACION DEL PIC
; SIN POWER ON RESET, SIN PROTEJER, SIN WASDOG Y CON OSCILADOR EXTERNO 
;
 __FUSES _PWRTE_OFF & _CP_OFF & _WDT_OFF & _XT_OSC



; NOTACION DECIMAL 

 radix   dec ; asigna numeros en notacion decimal por defecto
;--------------------------------------------------------------------------


;3) AREA DE DEFINICION DE VARIABLES (EN BLOQUE)

; VARIABLES DE RAM INTERNA


 cblock 0x0c    ; AQUI EMPIEZA EL ESPACIO DE VARIABLES	
        RAM_0C  ;Contador pausa
        RAM_0D  ;LIBRE PARA USAR
        RAM_0E  ;Contador pausa
        RAM_0F  ;LIBRE PARA USAR
        RAM_10  ;LIBRE PARA USAR
        RAM_11  ;Contador W en pausa Wx199
        RAM_12  ;Contador 199 en pausa Wx199
        usb; UNA VARIABLE CUALQUIERA QUE DEFINO YO
        endc     ; FINAL DEL BLOQUE DE VARIABLES



;--------------------------------------------------------------------------


; DEFINICION DE LOS PINES DEL PIC 

; NOTA: Esta zona es util, porque aqui podemos asignar a una palabra clave el puerto 
;y el bit de acceso, como en los ejemplos de abajo. Una instruccion del tipo bcf PORTB,6
;quedaria como bcf TX_SCEE, mucho mas legible (y portable)

        #define  PS2_RESET PORTA,4
     	#define  TX_SCEE   PORTB,6
	#define  DVD_IN    PORTB,1        

;4) AREA DE PROGRAMA

; VECTOR DE RESET. aqui es donde arranca el PIC al ser encendido

	org	0x0
        goto    COMIENZO        ;SALTA LA COMIENZO (verdadero) DEL PROGRAMA


; VECTOR DE INTERRUPCION. aqui es donde se salta si se produce una interrupcion y estas estan activadas.

        org     0x4
        retfie


; COMIENZO DEL PROGRAMA 

COMIENZO
        movlw   b'11000010'     ; configuracion del registro opcion
        option                  
     
        ; resto del programa: Esto te toca a ti ;)
;--------------------------------------------------------------------------
;5) AREA DE SUBRUTINAS
;--------------------------------------------------------------------------
;NOTA: Aqui ponemos la parte del codigo que sera llamada por CALL. Hay que tener en cuenta, que 
;algunos PIC's como el 12c508, solo admiten hacer call en la primera pagina de programa (las 
;primeros 256 instrucciones) y tambien alguna otra con las que usan PCL, se pierden a veces. 
;En ese caso es mejor poner esas rutinas despues de la del tratamiento de interrupcion o hacer
; un truco que cnsite en crear una tabla de saltos (ya explicare que es eso)


;rutinas de interes que controlan el tiempo

; PAUSA DE (W x 1 SEGUNDO) 

PAUSAWX1SG
        movwf   RAM_0E          ;
ETI_P1B movlw   4               ; 
        movwf   RAM_0C          ; 
ETI_P1A movlw   250             ;
        call    PAUSAWX1MSG     ;
        decfsz  RAM_0C,F        ;
        goto    ETI_P1A         ;
        decfsz  RAM_0E,F        ;
        goto    ETI_P1B         ;
        return               

; PAUSA DE 50 MILISEGUNDOS 



PAUSA50MSG
        movlw   50              ;
;ͻ
; PAUSA DE (W x 1 MILISEGUNDO) 
;ͼ
PAUSAWX1MSG
        movwf   RAM_11          ; rutina que ejecuta 200x(5-para 4Mhz o 15-para 12Mhz) us=1ms
ETI_042 movlw   199             ;
        movwf   RAM_12          ;
ETI_044 nop                     ;
        nop                    ;
 IF F12MHZ ; este codigo es aadido si se programa el PIC para 12 MHz
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
 ENDIF
        decfsz  RAM_12,F        ;
        goto    ETI_044         ;
        nop     
 IF F12MHZ
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
 ENDIF	    
                   
        decfsz  RAM_11,F        ;
        goto    ETI_042         ;
        return                  ;
;--------------------------------------------------------------------------

      	
	end ; final de programa

